program macro;

const
  infile        = 'input.txt';
  outfile       = 'output.txt';
  MaxN          = 9;
  MaxP          = 48620;       { C_18^9 }
type
  diagr         = array [1..MaxN] of byte; { 1..M, in [0..N] }
var
  N, M          : integer;
  X             : diagr;
  VXD           : Word;
  C             : array [0..MaxN, -1..MaxN] of word;
  W             : array [0..MaxP-1] of boolean;
    (* C[k,l] = card { (X_1,...,X_k) : l >= X_1 >= X_2 >= ... >= X_k >= 0 } *)

procedure calcA;
var k, l, i : integer;
begin
  for l:=0 to MaxN do C[0,l] := 1;
  for k:=1 to MaxN do
    begin
      C[k,-1] := 0;
      C[k,0] := 1;
      for l:=0 to MaxN do C[k,l] := C[k,l-1] + C[k-1,l]
    end
end;

procedure num2pos (N : word; var P : diagr);
var i, j : integer;
begin
  for i:=1 to M do
    begin
      j := 0;
      while (j<=MaxN) and (N>=C[M-i+1,j]) do inc(j);
      P[i] := j;
      N := N - C[M-i+1, j-1]
    end
end;

function pos2num (var P : diagr) : word;
var N : Word; i, j : integer;
begin
  N := 0;
  for i:=1 to M do
    N := N + C[M-i+1, P[i]-1];
  pos2num := N;
end;

var
  TP, NP  : diagr;
  PP      : word;

function calcW (P : word) : boolean;
var
  i, j, k        : integer;
begin
  num2pos (P, TP);
  calcW := true;
  for i:=1 to M do
    for j:=0 to TP[i]-1 do
      begin
        NP := TP;
        for k:=i to M do if NP[k]>j then NP[k]:=j;
        if not W[pos2num(NP)] then exit
      end;
  calcW := false
end;

procedure writeanswer;
var
  i, j, k, l     : integer;
  res            : array[1..81,1..2] of byte;
begin
  num2pos (VXD, TP);
  l := 0;
  for i:=1 to M do
    for j:=0 to TP[i]-1 do
      begin
        NP := TP;
        for k:=i to M do if NP[k]>j then NP[k]:=j;
        if not W[pos2num(NP)] then
          begin inc(l); res[l,1]:=i; res[l,2]:=j+1 end
      end;
  writeln (l);
  for i:=1 to l do writeln(res[i,1],' ',res[i,2])
end;

var i : word;
begin
  assign (input, 'input.txt'); reset (input);
  read (M, N);
  for i:=1 to M do read(X[i]);
  calcA;
  VXD := pos2num (X);
  W[0] := true;
  for i:=1 to VXD do W[i] := calcW (i);
  assign (output, 'output.txt'); rewrite(output);
  writeanswer;
end.
